Index: main/ngren.theme/trunk/ngren/theme/ngren_theme/full.html
===================================================================
--- main/ngren.theme/trunk/ngren/theme/ngren_theme/full.html	(revision 10361)
+++ main/ngren.theme/trunk/ngren/theme/ngren_theme/full.html	(revision 10362)
@@ -6,200 +6,200 @@
 <!--<![endif]-->
 <head>
-	<meta charset="utf-8">
-	<title>Example | NgREN - Nigerian Research and Education Network</title>
+  <meta charset="utf-8">
+  <title>Example | NgREN - Nigerian Research and Education Network</title>
         <base href="/" />
-	<meta name="viewport" content="width=device-width, initial-scale=1.0">
-	<meta name="description" content="NgREN's vision is to be a world-class research and education network in Africa, fulfilling stakeholder needs for communication and collaboration as a cornerstone for Nigeria’s economic and social transformation.">
-	<meta name="author" content="NgREN">
-
-	<!-- Le styles -->
-	<link href="css/bootstrap.min.css" rel="stylesheet">
-	<link href="css/bootstrap-responsive.min.css" rel="stylesheet">
-	<link href="css/style.css" rel="stylesheet">
-
-	<link href='http://fonts.googleapis.com/css?family=Open+Sans:400,700' rel='stylesheet' type='text/css'>
-
-	<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js"></script>
-	<script src="js/responsiveslides.min.js"></script>
-	<script src="js/jquery.vticker-min.js"></script>
-	<script src="js/bootstrap.js"></script>
-	<script src="js/functions.js"></script>
-
-	<!-- HTML5 shim, for IE6-8 support of HTML5 elements and CSS3 Media Queries -->
-	<!--[if lt IE 9]>
-	<script src="js/html5shiv.js"></script>
-	<script src="js/css3-mediaqueries.js"></script>
-	<![endif]-->
-
-	<!-- Fav and touch icons -->
-	<link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
+  <meta name="viewport" content="width=device-width, initial-scale=1.0">
+  <meta name="description" content="NgREN's vision is to be a world-class research and education network in Africa, fulfilling stakeholder needs for communication and collaboration as a cornerstone for Nigeria’s economic and social transformation.">
+  <meta name="author" content="NgREN">
+
+  <!-- Le styles -->
+  <link href="css/bootstrap.min.css" rel="stylesheet">
+  <link href="css/bootstrap-responsive.min.css" rel="stylesheet">
+  <link href="css/style.css" rel="stylesheet">
+
+  <link href='http://fonts.googleapis.com/css?family=Open+Sans:400,700' rel='stylesheet' type='text/css'>
+
+  <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js"></script>
+  <script src="js/responsiveslides.min.js"></script>
+  <script src="js/jquery.vticker-min.js"></script>
+  <script src="js/bootstrap.js"></script>
+  <script src="js/functions.js"></script>
+
+  <!-- HTML5 shim, for IE6-8 support of HTML5 elements and CSS3 Media Queries -->
+  <!--[if lt IE 9]>
+  <script src="js/html5shiv.js"></script>
+  <script src="js/css3-mediaqueries.js"></script>
+  <![endif]-->
+
+  <!-- Fav and touch icons -->
+  <link rel="shortcut icon" type="image/x-icon" href="favicon.ico" />
 </head>
 
 <body>
 
-	<!-- Facebook -->
-	<div id="fb-root"></div>
-	<script>(function(d, s, id) {
-	var js, fjs = d.getElementsByTagName(s)[0];
-	if (d.getElementById(id)) return;
-	js = d.createElement(s); js.id = id;
-	js.src = "//connect.facebook.net/es_LA/all.js#xfbml=1&appId=106017272902221";
-	fjs.parentNode.insertBefore(js, fjs);
-	}(document, 'script', 'facebook-jssdk'));</script>
-
-	<div class="container">
-
-	<div class="masthead">
-		<div class="navbar">
-		<div class="navbar-inner">
-			<div class="container relative">
-				<div id="header-head">
-					<div id="logo-container">
-						<a href="home.html">
-							<img id="logo" src="img/ngren_logo.png" alt="NgREN logo" />
-						</a>
-						<h1><a href="home.html">Nigerian Research and<br/>Education Network</a></h1>
-					</div>
-                                        <div class="btn-group pull-right btn-small"
-                                             id="user-options">
-                                          <a class="btn btn-small btn-primary"
-                                             href="#">
-                                            <i class="icon-user icon-white"></i>
-                                            <span id="user-options-name">
-                                              Username
-                                            </span>
-                                          </a>
-                                          <a class="btn btn-small btn-primary
-                                                    dropdown-toggle"
-                                             data-toggle="dropdown"
-                                             href="#">
-                                            <span class="caret"></span>
-                                          </a>
-                                          <ul class="dropdown-menu btn-small">
-                                            <li><a href="#">Dashboard</a></li>
-                                            <li><a href="#">Logout</a></li>
-                                          </ul>
-                                        </div><!-- user-options -->
-					<form class="navbar-form pull-right">
-						<input type="text" />
-						<button class="btn btn-primary btn-small search-btn" type="submit">Search</button>
-					</form>
-				</div>
-				<button type="button" class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
-					<span>Menu <b class="caret"></b></span>
-				</button>
-				<div id="menu-collapse" class="nav-collapse collapse">
-					<div class="nav-container">
-						<ul class="nav">
-							<li><a href="home.html">Home</a></li>
-							<li class="dropdown">
-								<a href="about-us.html" data-toggle="dropdown" class="dropdown-toggle disabled">About us <b class="caret"></b></a>
-								<ul class="dropdown-menu">
-									<li ><a href="example.html">Board</a></li>
-									<li ><a href="example.html">Plans</a></li>
-									<li ><a href="example.html">Policies</a></li>
-									<li ><a href="example.html">Topology</a></li>
-									<li ><a href="example.html">News and events</a></li>
-								</ul>
-							</li>
-							<li class="dropdown active">
-								<a href="services.html" data-toggle="dropdown" class="dropdown-toggle disabled">Services <b class="caret"></b></a>
-								<ul class="dropdown-menu">
-									<li ><a href="example.html">Unified communications</a></li>
-									<li ><a href="example.html">Video conferencing</a></li>
-									<li ><a href="example.html">Domain name services</a></li>
-									<li ><a href="example.html">Caching services</a></li>
-									<li ><a href="example.html">Digital content</a></li>
-									<li ><a href="example.html">Network Security (CERT)</a></li>
-									<li ><a href="example.html">Email and messaging</a></li>
-									<li ><a href="example.html">Colocation</a></li>
-									<li ><a href="example.html">Bandwidth supply and management</a></li>
-									<li ><a href="example.html">Backbone transmission</a></li>
-								</ul>
-							</li>
-							<li><a href="example.html">FAQ</a></li>
-						</ul>
-					</div>
-				</div>
-			</div>
-		</div>
-		</div><!-- /.navbar -->
-	</div>
-
-
-
-	<!-- CONTENT -->
-	<div class="full-col">
-	<div class="content-container gradient-radius-module">
-		<h1>Example</h1>
-		<ul class="breadcrumb">
-			<li><a href="home.html">Home</a></li>
-			<li class="separator">&raquo;</li>
-			<li>Example</li>
-		</ul>
-		<p>Unified communications allow institutions on the REN network to call each other across the NgREN private network. Unified communications allow institutions on the REN network to call each other across the NgREN private network.</p>
-		<img class="left-image" src="img/nigerian-woman3.jpg" alt="nigerian woman 3" style="width:220px;" />
-		<p>Unified communications <strong>allow institutions on the REN network to call each other across the NgREN private network</strong>. Unified communications allow institutions on the REN network to call each other across the NgREN private network. Unified communications allow institutions on the REN network to call each other <a href="example.html">across the NgREN private network</a>. Unified communications allow institutions on the REN network to call each other across the NgREN private network. Unified communications allow institutions on the REN network to call each other across the NgREN private network.</p>
-		<br/>
-		<h3>Head title</h3>
-		<ul>
-			<li>Unified communications allow institutions on the REN network to call each other</li>
-			<li>across the NgREN private network. Unified communications allow</li>
-			<li>Unified communications allow institutions on the REN network to call each other</li>
-			<li>across the NgREN private network. Unified communications allow</li>
-		</ul>
-
-		<div class="post-social">
-			<div class="facebook">
-				<div class="fb-like" data-href="http://www.facebook.com/informationnigeria" data-send="false" data-layout="button_count" data-width="90" data-show-faces="false"></div>
-			</div>
-			<div class="twitter">
-				<a href="https://twitter.com/share" class="twitter-share-button" data-url="http://www.facebook.com/informationnigeria">Tweet</a>
-				<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+'://platform.twitter.com/widgets.js';fjs.parentNode.insertBefore(js,fjs);}}(document, 'script', 'twitter-wjs');</script>
-			</div>
-		</div>
-		<div style="clear:both;"></div>
-
-	</div>
-	</div>
-
-
-	<div class="footer">
-		<div class="copyright">
-			<span>&copy; Nigerian Research and Education Network</span>
-			<script type="text/javascript">
-			renderCurrentYear();
-			</script>
-		</div>
-		<div class="address">
-			<ul>
-				<li>NgREN</li>
-				<li>National University Commission</li>
-				<li>Aja Nwachukwu House</li>
-				<li>Aguiyi Ironsi Street</li>
-				<li>Maitama District</li>
-				<li>Abuja, Nigeria</li>
-			</ul>
-		</div>
-		<div class="section">
-			<ul>
-				<li class="title">&raquo; NgREN</li>
-				<li><a href="example.html">Contact</a></li>
-				<li><a href="example.html">Sitemap</a></li>
-			</ul>
-		</div>
-	</div>
-
-	</div> <!-- /container -->
-
-	<!-- Le javascript
-	================================================== -->
-	<!-- Placed at the end of the document so the pages load faster -->
-
-	<script type="text/javascript">
-	$(document).ready(function() {
-		initInnerPageFunctions();
-	});
-	</script>
+  <!-- Facebook -->
+  <div id="fb-root"></div>
+  <script>(function(d, s, id) {
+  var js, fjs = d.getElementsByTagName(s)[0];
+  if (d.getElementById(id)) return;
+  js = d.createElement(s); js.id = id;
+  js.src = "//connect.facebook.net/es_LA/all.js#xfbml=1&appId=106017272902221";
+  fjs.parentNode.insertBefore(js, fjs);
+  }(document, 'script', 'facebook-jssdk'));</script>
+
+  <div class="container">
+
+  <div class="masthead">
+    <div class="navbar">
+    <div class="navbar-inner">
+      <div class="container relative">
+        <div id="header-head">
+          <div id="logo-container">
+            <a href="home.html">
+              <img id="logo" src="img/ngren_logo.png" alt="NgREN logo" />
+            </a>
+            <h1><a href="home.html">Nigerian Research and<br/>Education Network</a></h1>
+          </div>
+          <div class="btn-group pull-right btn-small"
+               id="user-options">
+            <a class="btn btn-small btn-primary"
+               href="#">
+              <i class="icon-user icon-white"></i>
+              <span id="user-options-name">
+                Username
+              </span>
+            </a>
+            <a class="btn btn-small btn-primary
+                      dropdown-toggle"
+               data-toggle="dropdown"
+               href="#">
+              <span class="caret"></span>
+            </a>
+            <ul class="dropdown-menu btn-small">
+              <li><a href="#">Dashboard</a></li>
+              <li><a href="#">Logout</a></li>
+            </ul>
+          </div><!-- user-options -->
+          <form class="navbar-form pull-right">
+            <input type="text" />
+            <button class="btn btn-primary btn-small search-btn" type="submit">Search</button>
+          </form>
+        </div>
+        <button type="button" class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
+          <span>Menu <b class="caret"></b></span>
+        </button>
+        <div id="menu-collapse" class="nav-collapse collapse">
+          <div class="nav-container">
+            <ul class="nav">
+              <li><a href="home.html">Home</a></li>
+              <li class="dropdown">
+                <a href="about-us.html" data-toggle="dropdown" class="dropdown-toggle disabled">About us <b class="caret"></b></a>
+                <ul class="dropdown-menu">
+                  <li ><a href="example.html">Board</a></li>
+                  <li ><a href="example.html">Plans</a></li>
+                  <li ><a href="example.html">Policies</a></li>
+                  <li ><a href="example.html">Topology</a></li>
+                  <li ><a href="example.html">News and events</a></li>
+                </ul>
+              </li>
+              <li class="dropdown active">
+                <a href="services.html" data-toggle="dropdown" class="dropdown-toggle disabled">Services <b class="caret"></b></a>
+                <ul class="dropdown-menu">
+                  <li ><a href="example.html">Unified communications</a></li>
+                  <li ><a href="example.html">Video conferencing</a></li>
+                  <li ><a href="example.html">Domain name services</a></li>
+                  <li ><a href="example.html">Caching services</a></li>
+                  <li ><a href="example.html">Digital content</a></li>
+                  <li ><a href="example.html">Network Security (CERT)</a></li>
+                  <li ><a href="example.html">Email and messaging</a></li>
+                  <li ><a href="example.html">Colocation</a></li>
+                  <li ><a href="example.html">Bandwidth supply and management</a></li>
+                  <li ><a href="example.html">Backbone transmission</a></li>
+                </ul>
+              </li>
+              <li><a href="example.html">FAQ</a></li>
+            </ul>
+          </div>
+        </div>
+      </div>
+    </div>
+    </div><!-- /.navbar -->
+  </div>
+
+
+
+  <!-- CONTENT -->
+  <div class="full-col">
+  <div class="content-container gradient-radius-module">
+    <h1>Example</h1>
+    <ul class="breadcrumb">
+      <li><a href="home.html">Home</a></li>
+      <li class="separator">&raquo;</li>
+      <li>Example</li>
+    </ul>
+    <p>Unified communications allow institutions on the REN network to call each other across the NgREN private network. Unified communications allow institutions on the REN network to call each other across the NgREN private network.</p>
+    <img class="left-image" src="img/nigerian-woman3.jpg" alt="nigerian woman 3" style="width:220px;" />
+    <p>Unified communications <strong>allow institutions on the REN network to call each other across the NgREN private network</strong>. Unified communications allow institutions on the REN network to call each other across the NgREN private network. Unified communications allow institutions on the REN network to call each other <a href="example.html">across the NgREN private network</a>. Unified communications allow institutions on the REN network to call each other across the NgREN private network. Unified communications allow institutions on the REN network to call each other across the NgREN private network.</p>
+    <br/>
+    <h3>Head title</h3>
+    <ul>
+      <li>Unified communications allow institutions on the REN network to call each other</li>
+      <li>across the NgREN private network. Unified communications allow</li>
+      <li>Unified communications allow institutions on the REN network to call each other</li>
+      <li>across the NgREN private network. Unified communications allow</li>
+    </ul>
+
+    <div class="post-social">
+      <div class="facebook">
+        <div class="fb-like" data-href="http://www.facebook.com/informationnigeria" data-send="false" data-layout="button_count" data-width="90" data-show-faces="false"></div>
+      </div>
+      <div class="twitter">
+        <a href="https://twitter.com/share" class="twitter-share-button" data-url="http://www.facebook.com/informationnigeria">Tweet</a>
+        <script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+'://platform.twitter.com/widgets.js';fjs.parentNode.insertBefore(js,fjs);}}(document, 'script', 'twitter-wjs');</script>
+      </div>
+    </div>
+    <div style="clear:both;"></div>
+
+  </div>
+  </div>
+
+
+  <div class="footer">
+    <div class="copyright">
+      <span>&copy; Nigerian Research and Education Network</span>
+      <script type="text/javascript">
+      renderCurrentYear();
+      </script>
+    </div>
+    <div class="address">
+      <ul>
+        <li>NgREN</li>
+        <li>National University Commission</li>
+        <li>Aja Nwachukwu House</li>
+        <li>Aguiyi Ironsi Street</li>
+        <li>Maitama District</li>
+        <li>Abuja, Nigeria</li>
+      </ul>
+    </div>
+    <div class="section">
+      <ul>
+        <li class="title">&raquo; NgREN</li>
+        <li><a href="example.html">Contact</a></li>
+        <li><a href="example.html">Sitemap</a></li>
+      </ul>
+    </div>
+  </div>
+
+  </div> <!-- /container -->
+
+  <!-- Le javascript
+  ================================================== -->
+  <!-- Placed at the end of the document so the pages load faster -->
+
+  <script type="text/javascript">
+  $(document).ready(function() {
+    initInnerPageFunctions();
+  });
+  </script>
 
 </body>