Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/browser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/browser.py	(revision 10376)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/browser.py	(revision 10377)
@@ -78,4 +78,7 @@
     """
 
+    def _not_paid(self):
+        return self.context.state in ('initialized', 'started',)
+
     @property
     def form_fields(self):
@@ -98,4 +101,45 @@
         #form_fields['perm_address'].custom_widget = BytesDisplayWidget
         form_fields['notice'].custom_widget = BytesDisplayWidget
+        if not getattr(self.context, 'student_id'):
+            form_fields = form_fields.omit('student_id')
+        if not getattr(self.context, 'screening_score'):
+            form_fields = form_fields.omit('screening_score')
+        if not getattr(self.context, 'screening_venue') or self._not_paid():
+            form_fields = form_fields.omit('screening_venue')
+        if not getattr(self.context, 'screening_date') or self._not_paid():
+            form_fields = form_fields.omit('screening_date')
+        return form_fields
+
+class NigeriaPDFApplicationSlip(PDFApplicationSlip):
+
+    def _reduced_slip(self):
+        return getattr(self.context, 'result_uploaded', False)
+
+    @property
+    def form_fields(self):
+        if self.target is not None and self.target.startswith('pg'):
+            form_fields = grok.AutoFields(INigeriaPGApplicant)
+            for field in PG_OMIT_PDF_FIELDS:
+                form_fields = form_fields.omit(field)
+        elif self.target is not None and self.target.startswith('putme'):
+            form_fields = grok.AutoFields(INigeriaUGApplicant)
+            if self._reduced_slip():
+                for field in PUTME_OMIT_RESULT_SLIP_FIELDS:
+                    form_fields = form_fields.omit(field)
+            else:
+                for field in PUTME_OMIT_PDF_FIELDS:
+                    form_fields = form_fields.omit(field)
+        elif self.target is not None and self.target.startswith('pude'):
+            form_fields = grok.AutoFields(INigeriaUGApplicant)
+            if self._reduced_slip():
+                for field in PUDE_OMIT_RESULT_SLIP_FIELDS:
+                    form_fields = form_fields.omit(field)
+            else:
+                for field in PUDE_OMIT_PDF_FIELDS:
+                    form_fields = form_fields.omit(field)
+        else:
+            form_fields = grok.AutoFields(INigeriaUGApplicant)
+            for field in UG_OMIT_PDF_FIELDS:
+                form_fields = form_fields.omit(field)
         if not getattr(self.context, 'student_id'):
             form_fields = form_fields.omit('student_id')
@@ -108,53 +152,4 @@
         return form_fields
 
-class NigeriaPDFApplicationSlip(PDFApplicationSlip):
-
-    def _reduced_slip(self):
-        return getattr(self.context, 'result_uploaded', False)
-
-    #@property
-    #def note(self):
-    #    if self.target is not None and not self.target.startswith('pg') \
-    #        and not self._reduced_slip():
-    #        return _(u'<br /><br /><br />'
-    #                  'Comfirm your exam venue 72 hours to the exam.')
-    #    return
-
-    @property
-    def form_fields(self):
-        if self.target is not None and self.target.startswith('pg'):
-            form_fields = grok.AutoFields(INigeriaPGApplicant)
-            for field in PG_OMIT_PDF_FIELDS:
-                form_fields = form_fields.omit(field)
-        elif self.target is not None and self.target.startswith('putme'):
-            form_fields = grok.AutoFields(INigeriaUGApplicant)
-            if self._reduced_slip():
-                for field in PUTME_OMIT_RESULT_SLIP_FIELDS:
-                    form_fields = form_fields.omit(field)
-            else:
-                for field in PUTME_OMIT_PDF_FIELDS:
-                    form_fields = form_fields.omit(field)
-        elif self.target is not None and self.target.startswith('pude'):
-            form_fields = grok.AutoFields(INigeriaUGApplicant)
-            if self._reduced_slip():
-                for field in PUDE_OMIT_RESULT_SLIP_FIELDS:
-                    form_fields = form_fields.omit(field)
-            else:
-                for field in PUDE_OMIT_PDF_FIELDS:
-                    form_fields = form_fields.omit(field)
-        else:
-            form_fields = grok.AutoFields(INigeriaUGApplicant)
-            for field in UG_OMIT_PDF_FIELDS:
-                form_fields = form_fields.omit(field)
-        if not getattr(self.context, 'student_id'):
-            form_fields = form_fields.omit('student_id')
-        if not getattr(self.context, 'screening_score'):
-            form_fields = form_fields.omit('screening_score')
-        if not getattr(self.context, 'screening_venue'):
-            form_fields = form_fields.omit('screening_venue')
-        if not getattr(self.context, 'screening_date'):
-            form_fields = form_fields.omit('screening_date')
-        return form_fields
-
 class NigeriaApplicantManageFormPage(ApplicantManageFormPage):
     """A full edit view for applicant data.