Index: main/waeup.imostate/trunk/src/waeup/imostate/applicants/browser.py
===================================================================
--- main/waeup.imostate/trunk/src/waeup/imostate/applicants/browser.py	(revision 10371)
+++ main/waeup.imostate/trunk/src/waeup/imostate/applicants/browser.py	(revision 10380)
@@ -43,4 +43,9 @@
     )
 
+UG_OMIT_DISPLAY_FIELDS += ('course2',)
+UG_OMIT_PDF_FIELDS += ('course2',)
+UG_OMIT_MANAGE_FIELDS += ('course2',)
+UG_OMIT_EDIT_FIELDS += ('course2',)
+
 from waeup.imostate.applicants.workflow import STARTED
 
Index: main/waeup.imostate/trunk/src/waeup/imostate/applicants/interfaces.py
===================================================================
--- main/waeup.imostate/trunk/src/waeup/imostate/applicants/interfaces.py	(revision 10371)
+++ main/waeup.imostate/trunk/src/waeup/imostate/applicants/interfaces.py	(revision 10380)
@@ -21,4 +21,6 @@
 from zope import schema
 from zope.interface import Attribute, invariant, Invalid
+from waeup.kofa.schema import FormattedDate, TextLineChoice
+from waeup.kofa.schoolgrades import ResultEntryField
 from waeup.kofa.applicants.interfaces import (
     IApplicantBaseData,
@@ -36,5 +38,5 @@
 from waeup.imostate.interfaces import MessageFactory as _
 
-class ICustomUGApplicant(INigeriaUGApplicant):
+class ICustomUGApplicant(IApplicantBaseData):
     """An undergraduate applicant.
 
@@ -43,4 +45,89 @@
     adding them to the UG_OMIT* tuples.
     """
+
+    nationality = schema.Choice(
+        source = nats_vocab,
+        title = _(u'Nationality'),
+        required = True,
+        )
+    lga = schema.Choice(
+        source = LGASource(),
+        title = _(u'State/LGA (Nigerians only)'),
+        required = False,
+        )
+    #perm_address = schema.Text(
+    #    title = _(u'Permanent Address'),
+    #    required = False,
+    #    )
+    course1 = schema.Choice(
+        title = _(u'Programme Desired'),
+        source = AppCatCertificateSource(),
+        required = True,
+        )
+
+    olevel_type = schema.Choice(
+        title = _(u'Qualification Obtained'),
+        required = False,
+        readonly = False,
+        vocabulary = exam_types,
+        )
+    olevel_school = schema.TextLine(
+        title = _(u'Institution Attended'),
+        required = False,
+        readonly = False,
+        )
+    olevel_exam_number = schema.TextLine(
+        title = _(u'Exam Number'),
+        required = False,
+        readonly = False,
+        )
+    olevel_exam_date = FormattedDate(
+        title = _(u'Exam Date'),
+        required = False,
+        readonly = False,
+        show_year = True,
+        )
+    olevel_results = schema.List(
+        title = _(u'Exam Results'),
+        value_type = ResultEntryField(),
+        required = False,
+        readonly = False,
+        default = [],
+        )
+
+    notice = schema.Text(
+        title = _(u'Notice'),
+        required = False,
+        )
+    screening_venue = schema.TextLine(
+        title = _(u'Screening Venue'),
+        required = False,
+        )
+    screening_date = schema.TextLine(
+        title = _(u'Screening Date'),
+        required = False,
+        )
+    screening_score = schema.Int(
+        title = _(u'Screening Score (%)'),
+        required = False,
+        )
+    result_uploaded = schema.Bool(
+        title = _(u'Result uploaded'),
+        default = False,
+        )
+    student_id = schema.TextLine(
+        title = _(u'Student Id'),
+        required = False,
+        readonly = False,
+        )
+    course_admitted = schema.Choice(
+        title = _(u'Programme Admitted'),
+        source = CertificateSource(),
+        required = False,
+        )
+    locked = schema.Bool(
+        title = _(u'Form locked'),
+        default = False,
+        )
 
 class ICustomApplicant(ICustomUGApplicant):
Index: main/waeup.imostate/trunk/src/waeup/imostate/applicants/utils.py
===================================================================
--- main/waeup.imostate/trunk/src/waeup/imostate/applicants/utils.py	(revision 10371)
+++ main/waeup.imostate/trunk/src/waeup/imostate/applicants/utils.py	(revision 10380)
@@ -32,5 +32,7 @@
     SEPARATORS_DICT = {
         'form.applicant_id': _(u'Base Data'),
-        'form.course1': _(u'Programmes/Courses Desired'),
+        #'form.course1': _(u'Programmes/Courses Desired'),
+        'form.olevel_type': _(u"'O' Level Records"),
+        'form.notice': _(u'Application Process Information'),
       }
 