Index: main/waeup.imostate/trunk/src/waeup/imostate/applicants/browser.py
===================================================================
--- main/waeup.imostate/trunk/src/waeup/imostate/applicants/browser.py	(revision 10381)
+++ main/waeup.imostate/trunk/src/waeup/imostate/applicants/browser.py	(revision 10382)
@@ -215,9 +215,9 @@
         if not store.getFileByContext(self.context, attr=u'extraform.pdf'):
             return _('No extra information form pdf file uploaded.')
-        if not store.getFileByContext(self.context, attr=u'refereeform.pdf'):
-            return _('No referee form pdf file uploaded.')
-        if self.target is not None and self.target.startswith('pg') \
-            and not store.getFileByContext(self.context, attr=u'credentials.pdf'):
-            return _('No credentials pdf file uploaded.')
+        #if not store.getFileByContext(self.context, attr=u'refereeform.pdf'):
+        #    return _('No referee form pdf file uploaded.')
+        #if self.target is not None and self.target.startswith('pg') \
+        #    and not store.getFileByContext(self.context, attr=u'credentials.pdf'):
+        #    return _('No credentials pdf file uploaded.')
         if not self.request.form.get('confirm_passport', False):
             return _('Passport picture confirmation box not ticked.')
Index: main/waeup.imostate/trunk/src/waeup/imostate/applicants/browser_templates/applicanteditpage.pt
===================================================================
--- main/waeup.imostate/trunk/src/waeup/imostate/applicants/browser_templates/applicanteditpage.pt	(revision 10381)
+++ main/waeup.imostate/trunk/src/waeup/imostate/applicants/browser_templates/applicanteditpage.pt	(revision 10382)
@@ -20,11 +20,12 @@
       <a href="https://imostate.waeup.org/downloads/AttestationForm.pdf"
         i18n:translate="">
-    <strong>Attestation Form</strong></a>.
-    Then scan the filled form together with other
-    documents required for application:
-    (1) Local Government Certificate of Indegen,
+    <strong>Attestation Form</strong></a>then,
+    upload a scanned copy of the filled attestation form.
+    Also, scan the following other documents required for application:
+    (1) Local Government Certificate of Indigene,
     (2) Credentials and the
-    (3) NYSC Discharge Certificate. Print these four scanned documents
-    into a single pdf file and upload the file with the form below.
+    (3) NYSC Discharge Certificate.
+    Print these four scanned documents into a single pdf file and
+    upload the file as Extra Applicant Information Form below.
     <br /><br />
   </p>
@@ -67,40 +68,4 @@
           </p>
           <input type="file" name="form.extraform" />
-          <br />
-          <span i18n:translate="">
-            Max. file size:
-          </span>
-          <span tal:replace="view/max_file_upload_size">10 KB</span>
-      </tr>
-      <tr>
-        <td class="fieldname" i18n:translate="">
-          Referee's Form:
-        </td>
-        <td>
-          <p tal:condition="python: view.file_exists('refereeform.pdf')">
-            <a href="refereeform.pdf"
-               i18n:translate="">
-              Download pdf file
-            </a>
-          </p>
-          <input type="file" name="form.refereeform" />
-          <br />
-          <span i18n:translate="">
-            Max. file size:
-          </span>
-          <span tal:replace="view/max_file_upload_size">10 KB</span>
-      </tr>
-      <tr tal:condition="python: view.target.startswith('pg')">
-        <td class="fieldname" i18n:translate="">
-          Credentials:
-        </td>
-        <td>
-          <p tal:condition="python: view.file_exists('credentials.pdf')">
-            <a href="credentials.pdf"
-               i18n:translate="">
-              Download pdf file
-            </a>
-          </p>
-          <input type="file" name="form.credentials" />
           <br />
           <span i18n:translate="">
Index: main/waeup.imostate/trunk/src/waeup/imostate/applicants/interfaces.py
===================================================================
--- main/waeup.imostate/trunk/src/waeup/imostate/applicants/interfaces.py	(revision 10381)
+++ main/waeup.imostate/trunk/src/waeup/imostate/applicants/interfaces.py	(revision 10382)
@@ -131,4 +131,9 @@
         )
 
+ICustomUGApplicant[
+    'locked'].order =  IApplicantBaseData['suspended'].order
+ICustomUGApplicant[
+    'result_uploaded'].order =  ICustomUGApplicant['suspended'].order
+
 class ICustomApplicant(ICustomUGApplicant):
     """An interface for both types of applicants.
Index: main/waeup.imostate/trunk/src/waeup/imostate/applicants/tests/test_browser.py
===================================================================
--- main/waeup.imostate/trunk/src/waeup/imostate/applicants/tests/test_browser.py	(revision 10381)
+++ main/waeup.imostate/trunk/src/waeup/imostate/applicants/tests/test_browser.py	(revision 10382)
@@ -161,95 +161,4 @@
         self.assertTrue(fd is None)
 
-    def test_upload_refereeform_by_student(self):
-        self.login()
-        self.browser.open(self.edit_path)
-        # Create a pseudo file and select it to be uploaded in form
-        pdf_content = 'A' * 1024 * 600  # A string of 600 KB size
-        pseudo_file = StringIO(pdf_content)
-        ctrl = self.browser.getControl(name='form.refereeform')
-        file_ctrl = ctrl.mech_control
-        file_ctrl.add_file(pseudo_file, filename='myform.pdf')
-        self.browser.getControl("Save").click() # submit form
-        # We get a warning message
-        self.assertTrue(
-            'Uploaded file is too big' in self.browser.contents)
-        # Create a pseudo file with acceptable size
-        pdf_content = 'A' * 1024 * 300  # A string of 300 KB size
-        pseudo_file = StringIO(pdf_content)
-        ctrl = self.browser.getControl(name='form.refereeform')
-        file_ctrl = ctrl.mech_control
-        file_ctrl.add_file(pseudo_file, filename='myform.pdf')
-        self.browser.getControl("Save").click() # submit form
-        # Even though the form could not be saved ...
-        self.assertTrue('Required input is missing' in self.browser.contents)
-        # ... the file has been successfully uploaded
-        pdf_url = self.edit_path.replace('edit', 'refereeform.pdf')
-        self.browser.open(pdf_url)
-        self.assertEqual(
-            self.browser.headers['content-type'], 'application/pdf')
-        self.assertEqual(len(self.browser.contents), 307200)
-        # There is really a file stored for the applicant
-        storage = getUtility(IExtFileStore)
-        file_id = IFileStoreNameChooser(self.applicant).chooseName(
-            attr='refereeform.pdf')
-        # The stored file can be fetched
-        fd = storage.getFile(file_id)
-        file_len = len(fd.read())
-        self.assertEqual(file_len, 307200)
-        # A file link is displayed on the edit view ...
-        self.browser.open(self.edit_path)
-        self.assertTrue('<a href="refereeform.pdf">' in self.browser.contents)
-        # ... and on the dislay view
-        self.browser.open(self.view_path)
-        self.assertTrue('<a href="refereeform.pdf">Referee\'s Form</a>'
-            in self.browser.contents)
-
-    def test_upload_refereeform_by_manager(self):
-        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
-        self.browser.open(self.manage_path)
-        # Create a pseudo file with acceptable size
-        pdf_content = 'A' * 1024 * 300  # A string of 300 KB size
-        pseudo_file = StringIO(pdf_content)
-        ctrl = self.browser.getControl(name='form.refereeform')
-        file_ctrl = ctrl.mech_control
-        file_ctrl.add_file(pseudo_file, filename='myform.pdf')
-        self.browser.getControl("Save").click() # submit form
-        # Even though the form could not be saved ...
-        self.assertTrue('Required input is missing' in self.browser.contents)
-        # ... the file has been successfully uploaded
-        pdf_url = self.manage_path.replace('manage', 'refereeform.pdf')
-        self.browser.open(pdf_url)
-        self.assertEqual(
-            self.browser.headers['content-type'], 'application/pdf')
-        self.assertEqual(len(self.browser.contents), 307200)
-        # There is rally a file stored for the applicant
-        storage = getUtility(IExtFileStore)
-        file_id = IFileStoreNameChooser(self.applicant).chooseName(
-            attr='refereeform.pdf')
-        # The stored file can be fetched
-        fd = storage.getFile(file_id)
-        file_len = len(fd.read())
-        self.assertEqual(file_len, 307200)
-        # A file link is displayed on the edit view ...
-        self.browser.open(self.manage_path)
-        self.assertTrue('<a href="refereeform.pdf">' in self.browser.contents)
-        # ... and on the dislay view
-        self.browser.open(self.view_path)
-        self.assertTrue('<a href="refereeform.pdf">Referee\'s Form</a>'
-            in self.browser.contents)
-        # Adding file is properly logged
-        logfile = os.path.join(
-            self.app['datacenter'].storage, 'logs', 'applicants.log')
-        logcontent = open(logfile).read()
-        self.assertTrue(
-            'zope.mgr - waeup.imostate.applicants.browser.CustomApplicantManageFormPage'
-            ' - %s - saved: refereeform'
-            % (self.applicant.applicant_id)
-            in logcontent)
-        # When an applicant is removed, also the pdf files are gone.
-        del self.app['applicants']['app2011'][self.applicant.application_number]
-        fd = storage.getFile(file_id)
-        self.assertTrue(fd is None)
-
     def test_applicant_workflow(self):
         # Applicants can edit their record
@@ -275,7 +184,4 @@
         file_ctrl = ctrl.mech_control
         file_ctrl.add_file(pseudo_file, filename='myform.pdf')
-        ctrl = self.browser.getControl(name='form.refereeform')
-        file_ctrl = ctrl.mech_control
-        file_ctrl.add_file(pseudo_file, filename='myform.pdf')
 
         self.browser.getControl(name="confirm_passport").value = True