Index: main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py	(revision 10435)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py	(revision 10436)
@@ -130,4 +130,6 @@
         value_dict['grade'] = value.grade
         value_dict['weight'] = value.weight
+        semester_dict = getUtility(IKofaUtils).SEMESTER_DICT
+        value_dict['semester'] = semester_dict[value.semester]
         yield value_dict
 
@@ -1127,5 +1129,5 @@
     def render(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        Sem = translate(_('Sem.'), 'waeup.kofa', target_language=portal_language)
+        Term = translate(_('Term'), 'waeup.kofa', target_language=portal_language)
         Code = translate(_('Code'), 'waeup.kofa', target_language=portal_language)
         Title = translate(_('Title'), 'waeup.kofa', target_language=portal_language)
@@ -1139,5 +1141,5 @@
         tableheader = [(Code,'code', 2.5),
                          (Title,'title', 7),
-                         (Sem, 'semester', 1.5),
+                         (Term, 'semester', 1.5),
                          (Cred, 'credits', 1.5),
                          (Score, 'score', 1.5),
@@ -1287,5 +1289,5 @@
     def render(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
-        Sem = translate(_('Sem.'), 'waeup.kofa', target_language=portal_language)
+        Term = translate(_('Term'), 'waeup.kofa', target_language=portal_language)
         Code = translate(_('Code'), 'waeup.kofa', target_language=portal_language)
         Title = translate(_('Title'), 'waeup.kofa', target_language=portal_language)
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/studyleveleditpage.pt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/studyleveleditpage.pt	(revision 10435)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/studyleveleditpage.pt	(revision 10436)
@@ -12,5 +12,5 @@
     <tr>
       <th>&nbsp;</th>
-      <th i18n:translate="">Sem.</th>
+      <th i18n:translate="">Term</th>
       <th i18n:translate="">Code</th>
       <th i18n:translate="">Title</th>
@@ -29,5 +29,5 @@
         tal:condition="value/removable_by_student" />
       </td>
-      <td tal:content="value/semester">SEMESTER</td>
+      <td tal:content="value/semester">TERM</td>
       <td> <a tal:attributes="href value/__name__">
       <span tal:content="value/code">CODE</span>
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/studylevelmanagepage.pt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/studylevelmanagepage.pt	(revision 10435)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/studylevelmanagepage.pt	(revision 10436)
@@ -33,5 +33,5 @@
         <tr>
           <th>&nbsp;</th>
-          <th i18n:translate="">Sem.</th>
+          <th i18n:translate="">Term</th>
           <th i18n:translate="">Code</th>
           <th i18n:translate="">Title</th>
@@ -51,5 +51,5 @@
       		  tal:attributes="value value/__name__" />
           </td>
-          <td tal:content="value/semester">SEMESTER</td>
+          <td tal:content="value/semester">TERM</td>
           <td> <a tal:attributes="href value/__name__">
           <span tal:content="value/code">CODE</span>
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/studylevelpage.pt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/studylevelpage.pt	(revision 10435)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/studylevelpage.pt	(revision 10436)
@@ -23,5 +23,5 @@
   <thead>
     <tr>
-      <th i18n:translate="">Sem.</th>
+      <th i18n:translate="">Term</th>
       <th i18n:translate="">Code</th>
       <th i18n:translate="">Title</th>
@@ -38,5 +38,5 @@
   <tbody>
     <tr tal:repeat="value view/translated_values" class="gradeC">
-      <td tal:content="value/semester">SEMESTER</td>
+      <td tal:content="value/semester">TERM</td>
       <td> <a tal:attributes="href value/__name__">
       <span tal:content="value/code">CODE</span>
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/transcript.pt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/transcript.pt	(revision 10435)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/browser_templates/transcript.pt	(revision 10436)
@@ -34,5 +34,5 @@
       <th i18n:translate="">Level</th>
       <th i18n:translate="">Session</th>
-      <th i18n:translate="">Semester</th>
+      <th i18n:translate="">Term</th>
       <th i18n:translate="">Course</th>
       <th i18n:translate="">Title</th>
Index: main/waeup.kofa/trunk/src/waeup/kofa/university/vocabularies.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/university/vocabularies.py	(revision 10435)
+++ main/waeup.kofa/trunk/src/waeup/kofa/university/vocabularies.py	(revision 10436)
@@ -61,5 +61,5 @@
 
 class SemesterSource(ContextualDictSourceFactoryBase):
-    """An institution type source delivers semester or term descriptors.
+    """An institution type source delivers semester and/or term descriptors.
     """
     #: name of dict to deliver from kofa utils.