Index: main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py	(revision 10425)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/browser.py	(revision 10441)
@@ -158,4 +158,22 @@
         'level_verdict')
 
+    @property
+    def tabletitle(self):
+        portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
+        tabletitle = []
+        tabletitle.append(translate(_('1st Semester Courses'), 'waeup.kofa',
+            target_language=portal_language))
+        tabletitle.append(translate(_('2nd Semester Courses'), 'waeup.kofa',
+            target_language=portal_language))
+        tabletitle.append(translate(_('Level Courses'), 'waeup.kofa',
+            target_language=portal_language))
+        tabletitle.append(translate(_('1st Trimester Courses'), 'waeup.kofa',
+            target_language=portal_language))
+        tabletitle.append(translate(_('2nd Trimester Courses'), 'waeup.kofa',
+            target_language=portal_language))
+        tabletitle.append(translate(_('3rd Trimester Courses'), 'waeup.kofa',
+            target_language=portal_language))
+        return tabletitle
+
     def render(self):
         portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
@@ -168,27 +186,22 @@
             self.request, self.omit_fields)
         students_utils = getUtility(IStudentsUtils)
-        tabledata_1 = sorted(
-            [value for value in self.context.values() if value.semester == 1],
-            key=lambda value: str(value.semester) + value.code)
-        tabledata_2 = sorted(
-            [value for value in self.context.values() if value.semester == 2],
-            key=lambda value: str(value.semester) + value.code)
-        tabledata_3 = sorted(
-            [value for value in self.context.values() if value.semester == 3],
-            key=lambda value: str(value.semester) + value.code)
-        tableheader = [(Code,'code', 2.5),
-                         (Title,'title', 5),
-                         (Dept,'dcode', 1.5), (Faculty,'fcode', 1.5),
-                         (Cred, 'credits', 1.5),
-                         ]
+
+        tabledata = []
+        tableheader = []
+        contenttitle = []
+        for i in range(1,7):
+            tabledata.append(sorted(
+                [value for value in self.context.values() if value.semester == i],
+                key=lambda value: str(value.semester) + value.code))
+            tableheader.append([(Code,'code', 2.5),
+                             (Title,'title', 5),
+                             (Dept,'dcode', 1.5), (Faculty,'fcode', 1.5),
+                             (Cred, 'credits', 1.5),
+                             ])
         return students_utils.renderPDF(
             self, 'course_registration_slip.pdf',
             self.context.student, studentview,
-            tableheader_1=tableheader,
-            tabledata_1=tabledata_1,
-            tableheader_2=tableheader,
-            tabledata_2=tabledata_2,
-            tableheader_3=tableheader,
-            tabledata_3=tabledata_3,
+            tableheader=tableheader,
+            tabledata=tabledata,
             omit_fields=self.omit_fields
             )
@@ -199,4 +212,22 @@
 
     grok.name('course_result_slip.pdf')
+
+    @property
+    def tabletitle(self):
+        portal_language = getUtility(IKofaUtils).PORTAL_LANGUAGE
+        tabletitle = []
+        tabletitle.append(translate(_('1st Semester Courses'), 'waeup.kofa',
+            target_language=portal_language))
+        tabletitle.append(translate(_('2nd Semester Courses'), 'waeup.kofa',
+            target_language=portal_language))
+        tabletitle.append(translate(_('Level Courses'), 'waeup.kofa',
+            target_language=portal_language))
+        tabletitle.append(translate(_('1st Trimester Courses'), 'waeup.kofa',
+            target_language=portal_language))
+        tabletitle.append(translate(_('2nd Trimester Courses'), 'waeup.kofa',
+            target_language=portal_language))
+        tabletitle.append(translate(_('3rd Trimester Courses'), 'waeup.kofa',
+            target_language=portal_language))
+        return tabletitle
 
     @property
@@ -221,28 +252,23 @@
             self.request, self.omit_fields)
         students_utils = getUtility(IStudentsUtils)
-        tabledata_1 = sorted(
-            [value for value in self.context.values() if value.semester == 1],
-            key=lambda value: str(value.semester) + value.code)
-        tabledata_2 = sorted(
-            [value for value in self.context.values() if value.semester == 2],
-            key=lambda value: str(value.semester) + value.code)
-        tabledata_3 = sorted(
-            [value for value in self.context.values() if value.semester == 3],
-            key=lambda value: str(value.semester) + value.code)
-        tableheader = [(Code,'code', 2.5),
-                         (Title,'title', 5),
-                         (Dept,'dcode', 1.5), (Faculty,'fcode', 1.5),
-                         (Cred, 'credits', 1.5),
-                         (Grade, 'grade', 1.5),
-                         ]
+
+        tabledata = []
+        tableheader = []
+        contenttitle = []
+        for i in range(1,7):
+            tabledata.append(sorted(
+                [value for value in self.context.values() if value.semester == i],
+                key=lambda value: str(value.semester) + value.code))
+            tableheader.append([(Code,'code', 2.5),
+                             (Title,'title', 5),
+                             (Dept,'dcode', 1.5), (Faculty,'fcode', 1.5),
+                             (Cred, 'credits', 1.5),
+                             (Grade, 'grade', 1.5),
+                             ])
         return students_utils.renderPDF(
             self, 'course_registration_slip.pdf',
             self.context.student, studentview,
-            tableheader_1=tableheader,
-            tabledata_1=tabledata_1,
-            tableheader_2=tableheader,
-            tabledata_2=tabledata_2,
-            tableheader_3=tableheader,
-            tabledata_3=tabledata_3,
+            tableheader=tableheader,
+            tabledata=tabledata,
             omit_fields=self.omit_fields
             )
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/browser_templates/studyleveleditpage.pt
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/browser_templates/studyleveleditpage.pt	(revision 10425)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/browser_templates/studyleveleditpage.pt	(revision 10441)
@@ -12,5 +12,5 @@
     <tr>
       <th>&nbsp;</th>
-      <th i18n:translate="">Sem.</th>
+      <th i18n:translate="">Term</th>
       <th i18n:translate="">Code</th>
       <th i18n:translate="">Title</th>
@@ -29,5 +29,5 @@
         tal:condition="value/removable_by_student" />
       </td>
-      <td tal:content="value/semester">SEMESTER</td>
+      <td tal:content="value/semester" nowrap>TERM</td>
       <td> <a tal:attributes="href value/__name__">
       <span tal:content="value/code">CODE</span>
Index: main/waeup.uniben/trunk/src/waeup/uniben/students/browser_templates/studylevelpage.pt
===================================================================
--- main/waeup.uniben/trunk/src/waeup/uniben/students/browser_templates/studylevelpage.pt	(revision 10425)
+++ main/waeup.uniben/trunk/src/waeup/uniben/students/browser_templates/studylevelpage.pt	(revision 10441)
@@ -23,5 +23,5 @@
   <thead>
     <tr>
-      <th i18n:translate="">Sem.</th>
+      <th i18n:translate="">Term</th>
       <th i18n:translate="">Code</th>
       <th i18n:translate="">Title</th>
@@ -37,5 +37,5 @@
   <tbody>
     <tr tal:repeat="value view/translated_values" class="gradeC">
-      <td tal:content="value/semester">SEMESTER</td>
+      <td tal:content="value/semester" nowrap>TERM</td>
       <td> <a tal:attributes="href value/__name__">
       <span tal:content="value/code">CODE</span>