Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py	(revision 10446)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py	(revision 10447)
@@ -338,4 +338,5 @@
             'nationality,officer_comment,perm_address,personal_updated,'
             'phone,reg_number,sex,student_id,suspended,suspended_comment,'
+            'transript_address,'
             'password,state,history,certcode,is_postgrad,current_level,'
             'current_session\r\n')
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py	(revision 10446)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/interfaces.py	(revision 10447)
@@ -331,6 +331,19 @@
         )
 
+class IStudentTranscript(IKofaObject):
+    """Representation of student transcript data.
+
+    """
+
+    transript_address = schema.Text(
+        title = _(u'Address'),
+        required = False,
+        description = _(
+            u'Enter address the transcript has been shipped to.'),
+        )
+
+
 class IStudent(IStudentBase,IUGStudentClearance,IPGStudentClearance,
-    IStudentPersonal):
+    IStudentPersonal, IStudentTranscript):
     """Representation of a student.
 
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 10446)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 10447)
@@ -108,5 +108,5 @@
         'my adm code,0,my clr code,1981-02-04#,anna@sample.com,,'
         'Anna,Tester,234,M.,NG,,"Studentroad 21\nLagos 123456\n",,'
-        '+234-123-12345#,123,f,A111111,0,,,created'
+        '+234-123-12345#,123,f,A111111,0,,,,created'
         )
 
@@ -137,13 +137,14 @@
         result = open(self.outfile, 'rb').read()
         self.assertTrue(
-            'adm_code,clearance_locked,clr_code,date_of_birth,email,employer,'
-            'firstname,lastname,matric_number,middlename,nationality,officer_comment,'
-            'perm_address,personal_updated,'
-            'phone,reg_number,sex,student_id,suspended,suspended_comment,password,'
-            'state,history,certcode,is_postgrad,current_level,current_session\r\n'
-
-            'my adm code,0,my clr code,1981-02-04#,anna@sample.com,,'
-            'Anna,Tester,234,M.,NG,,"Studentroad 21\nLagos 123456\n",,'
-            '+234-123-12345#,123,f,A111111,0,,,created'
+            'adm_code,clearance_locked,clr_code,date_of_birth,email,'
+            'employer,firstname,lastname,matric_number,middlename,'
+            'nationality,officer_comment,perm_address,personal_updated,'
+            'phone,reg_number,sex,student_id,suspended,suspended_comment,'
+            'transript_address,password,state,history,certcode,is_postgrad,'
+            'current_level,current_session\r\n'
+            'my adm code,0,my clr code,'
+            '1981-02-04#,anna@sample.com,,Anna,Tester,234,M.,NG,,'
+            '"Studentroad 21\nLagos 123456\n",,+234-123-12345#,123,f,'
+            'A111111,0,,,,created'
             in result
             )
@@ -158,13 +159,13 @@
         result = open(self.outfile, 'rb').read()
         self.assertTrue(
-            'adm_code,clearance_locked,clr_code,date_of_birth,email,employer,'
-            'firstname,lastname,matric_number,middlename,nationality,officer_comment,'
-            'perm_address,personal_updated'
-            ',phone,reg_number,sex,student_id,suspended,suspended_comment,password,'
-            'state,history,certcode,is_postgrad,current_level,current_session\r\n'
-
+            'adm_code,clearance_locked,clr_code,date_of_birth,email,'
+            'employer,firstname,lastname,matric_number,middlename,'
+            'nationality,officer_comment,perm_address,personal_updated,'
+            'phone,reg_number,sex,student_id,suspended,suspended_comment,'
+            'transript_address,password,state,history,certcode,'
+            'is_postgrad,current_level,current_session\r\n'
             'my adm code,0,my clr code,1981-02-04#,anna@sample.com,,'
-            'Anna,Tester,234,M.,NG,,"Studentroad 21\nLagos 123456\n",,'
-            '+234-123-12345#,123,f,A111111,0,,,created'
+            'Anna,Tester,234,M.,NG,,"Studentroad 21\nLagos 123456\n"'
+            ',,+234-123-12345#,123,f,A111111,0,,,,created'
             in result
             )
@@ -178,13 +179,13 @@
         result = open(self.outfile, 'rb').read()
         self.assertTrue(
-            'adm_code,clearance_locked,clr_code,date_of_birth,email,employer,'
-            'firstname,lastname,matric_number,middlename,nationality,officer_comment,'
-            'perm_address,personal_updated'
-            ',phone,reg_number,sex,student_id,suspended,suspended_comment,password,'
-            'state,history,certcode,is_postgrad,current_level,current_session\r\n'
-
+            'adm_code,clearance_locked,clr_code,date_of_birth,email,'
+            'employer,firstname,lastname,matric_number,middlename,'
+            'nationality,officer_comment,perm_address,personal_updated,'
+            'phone,reg_number,sex,student_id,suspended,suspended_comment,'
+            'transript_address,password,state,history,certcode,'
+            'is_postgrad,current_level,current_session\r\n'
             'my adm code,0,my clr code,1981-02-04#,anna@sample.com,,'
-            'Anna,Tester,234,M.,NG,,"Studentroad 21\nLagos 123456\n",,'
-            '+234-123-12345#,123,f,A111111,0,,,created'
+            'Anna,Tester,234,M.,NG,,"Studentroad 21\nLagos 123456\n"'
+            ',,+234-123-12345#,123,f,A111111,0,,,,created'
             in result
             )